#ifndef _BBCENTITY_H
#define _BBCENTITY_H

#include <BBCPrerequisites.h>
#include <BBCSubEntity.h>

namespace BBC {

class _BBCExport Entity 
{
  protected:

	typedef std::vector<SubEntity*> SubEntityList;

	unsigned int mEntityHandle;

    unsigned int mBillboardHandle;

	SubEntityList mSubEntityList;

	Ogre::Mesh *mMesh;
	
  public:

    Entity();

    ~Entity();

	void createSubEntity();

	void addSubEntity(SubEntity *value);

	SubEntity* getSubEntity(unsigned int index);

	void removeSubEntity(unsigned int index);

	virtual Ogre::Mesh* getMesh();

	virtual void setMesh(Ogre::Mesh *value);

	void loadMesh(bool mergeSubMeshes);

	void getMeshPositions(Ogre::Vector3 position, Ogre::Quaternion orient, Ogre::Vector3 scale, bool mergeSubMeshes);

	void getMeshNormals(Ogre::Quaternion orient, Ogre::Vector3 scale, bool mergeSubMeshes);

	void getMeshVertexColours(bool mergeSubMeshes);

	void getMeshTexCoords(bool mergeSubMeshes);

	void getMeshFacesVerticesID(bool mergeSubMeshes);

	void setSubEntitiesDistinctVertexColours();

    unsigned int getEntityHandle();

    void setEntityHandle(unsigned int value);

	void sincronizeNumSubEntities();

	unsigned int getNumSubEntities();

	void mergeSubEntities();

};

}
#endif
