#ifndef _BBCMANAGER_H
#define _BBCMANAGER_H

#include <BBCPrerequisites.h>
#include <BBCSingleton.h>

//#include <ExampleFrameListener.h>

namespace BBC {

class _BBCExport Manager : public CSingleton<Manager> {
  public:
    Manager();
	
    ~Manager();

	static Manager& getSingleton(void);
    
	static Manager* getSingletonPtr(void);

	void initRenderWindow();

	Ogre::Mesh* loadMesh(Ogre::String name);

	Ogre::Mesh* loadXMLMesh(Ogre::String name);

	void loadResources();

	void saveMesh(Ogre::String name);

	void saveXMLMesh(Ogre::String name);

	void initialize(void);

	void shutdown(void);

	Ogre::MeshSerializer* getMeshSerializer(void);

	Ogre::XMLMeshSerializer* getXMLMeshSerializer(void);

  protected:
	  Ogre::Root* mOgreRoot;
	  Ogre::MeshSerializer *mMeshSerializer;
	  Ogre::XMLMeshSerializer *mXMLMeshSerializer;
	  Ogre::DefaultHardwareBufferManager *mDefaultHardwareBufferManager;
	  Ogre::RenderWindow *mWnd;
	  Ogre::SceneManager *mScene;
	  Ogre::RenderSystem *mRSys;
	  Ogre::Camera *mCam;
	  Ogre::Viewport *mView;
	  Ogre::Math *mMath;
	  //ExampleFrameListener *mFrameListener;
};

}

#endif

