#ifndef __BBCOGREMESHEXPORTER_H__
#define __BBCOGREMESHEXPORTER_H__

#include <BBCPrerequisites.h>
#include <BBCEntity.h>

namespace BBC {

class _BBCExport OgreMeshSerializer
{
    public:
        OgreMeshSerializer();

        virtual ~OgreMeshSerializer();

		void setEntity(Entity *entity);

		Entity* getEntity();

		void exportMesh(const Ogre::String& fileName, bool mergeSubMeshes, bool tangents);

    protected:

		Entity *mEntity;
		
		void buildMesh(Ogre::Mesh* pMesh, bool mergeSubmeshes);
		
		void generateEntityAABB(Ogre::Mesh* pMesh);
		
		void exportSubMeshes(Ogre::Mesh* pMesh);
        
		void exportSubMesh(Ogre::Mesh* pMesh, SubEntity *subEntity);
        
		template <typename T> void writeIndexes(T* buf, SubEntity *subEntity);
        
		void createVertexBuffer(Ogre::VertexData* vd, unsigned short bufIdx, UniqueVertexList *uniqueVertexList);

	};

}
#endif

