#ifndef _IMGBBOX_H
#define _IMGBBOX_H

#include "IMGPrerequisites.h"


namespace IMG {

#define BOUNDINGBOX_MAXVALUE 1000000000.
#define BOX_CORNER_xyz 0
#define BOX_CORNER_xyZ 1
#define BOX_CORNER_xYz 2
#define BOX_CORNER_xYZ 3
#define BOX_CORNER_Xyz 4
#define BOX_CORNER_XyZ 5
#define BOX_CORNER_XYz 6
#define BOX_CORNER_XYZ 7

#define BOX_CORNER_xy 0
#define BOX_CORNER_xY 2
#define BOX_CORNER_Xy 4
#define BOX_CORNER_XY 6

//*
//	this class encaplusalte the ogre::AxisAlignedBox
//*
class BBox: public Ogre::AxisAlignedBox {
  public:
    inline BBox() { BBox::StartBoundingBox(); }

    inline void StartBoundingBox() {
		 mMinimum.x =  BOUNDINGBOX_MAXVALUE;
         mMinimum.y =  BOUNDINGBOX_MAXVALUE;
         mMinimum.z =  BOUNDINGBOX_MAXVALUE;
         mMaximum.x = -BOUNDINGBOX_MAXVALUE;
         mMaximum.y = -BOUNDINGBOX_MAXVALUE;
         mMaximum.z = -BOUNDINGBOX_MAXVALUE;
       };

	inline Ogre::Vector3 GetMinimum() { return mMinimum; }

    //  
    //  Vector3 * GetMinimum()
    //  { 
    //  	Vector3 *Vector3;
    //	
    //	Ogre::Vector3 v = mMinimum;	
    //	Vector3.x = v.x;
    //	Vector3.y = v.y;
    //	Vector3.z = v.z;
    //	
    //	return v;
    //  }
    
	inline Ogre::Vector3 GetMaximum() { return mMaximum;};

    //
    //  Vector3 GetMaximum()
    //  { 
    //  
    //  	Vector3 Vector3;
    //	Ogre::Vector3 v = mMaximum;	
    //	Vector3.x = v.x;
    //	Vector3.y = v.y;
    //	Vector3.z = v.z;
    //  	return Vector3;
    //  }
    //  
    inline void AddBoundingVector3(float x, float y, float z) {
        if (x < mMinimum.x) mMinimum.x = x; if (x > mMaximum.x) mMaximum.x = x;
        if (y < mMinimum.y) mMinimum.y = y; if (y > mMaximum.y) mMaximum.y = y;
        if (z < mMinimum.z) mMinimum.z = z; if (z > mMaximum.z) mMaximum.z = z;
      };

    inline void Print() {
      	printf("\nValor de la Caixa: (%.4f, %.4f, %.4f) - (%.4f, %.4f, %.4f)\n\n", mMinimum.x, mMinimum.y, mMinimum.z, mMaximum.x, mMaximum.y, mMaximum.z);
      };

    //Ogre::Vector3* GetCorner (int corner) const
	inline Ogre::Vector3 * GetCorner(int corner) const {
       
       	//if (corner < 0 || corner > 7) return Ogre::Vector3 (-1111111111, -1111111111, -1111111111);
    	//return Ogre::AxisAlignedBox::getAllCorners ()[corner];
    	//printf("\nGetCorner: %d", corner);
    	
    	if (corner < 0 || corner > 7) return NULL;
    	
    	Ogre::Vector3 *vector;    	
    	switch (corner)
    	{
    		/*
    		case BOX_CORNER_xyz: return vector = new Ogre::Vector3(mMinimum.x, mMinimum.y, mMinimum.z );
    		case BOX_CORNER_xyZ: return vector = new Ogre::Vector3(mMinimum.x, mMinimum.y, mMaximum.z );
    		case BOX_CORNER_xYz: return vector = new Ogre::Vector3(mMinimum.x, mMaximum.y, mMinimum.z );
    		case BOX_CORNER_xYZ: return vector = new Ogre::Vector3(mMinimum.x, mMaximum.y, mMaximum.z );
    		case BOX_CORNER_Xyz: return vector = new Ogre::Vector3(mMaximum.x, mMinimum.y, mMinimum.z );
    		case BOX_CORNER_XyZ: return vector = new Ogre::Vector3(mMaximum.x, mMinimum.y, mMaximum.z );
    		case BOX_CORNER_XYz: return vector = new Ogre::Vector3(mMaximum.x, mMaximum.y, mMinimum.z );
    		case BOX_CORNER_XYZ: return vector = new Ogre::Vector3(mMaximum.x, mMaximum.y, mMaximum.z );
    		*/
			case BOX_CORNER_xyz: vector = new Ogre::Vector3(mMinimum.x, mMinimum.y, mMinimum.z ); break;
    		case BOX_CORNER_xyZ: vector = new Ogre::Vector3(mMinimum.x, mMinimum.y, mMaximum.z ); break;
    		case BOX_CORNER_xYz: vector = new Ogre::Vector3(mMinimum.x, mMaximum.y, mMinimum.z ); break;
    		case BOX_CORNER_xYZ: vector = new Ogre::Vector3(mMinimum.x, mMaximum.y, mMaximum.z ); break;
    		case BOX_CORNER_Xyz: vector = new Ogre::Vector3(mMaximum.x, mMinimum.y, mMinimum.z ); break;
    		case BOX_CORNER_XyZ: vector = new Ogre::Vector3(mMaximum.x, mMinimum.y, mMaximum.z ); break;
    		case BOX_CORNER_XYz: vector = new Ogre::Vector3(mMaximum.x, mMaximum.y, mMinimum.z ); break;
    		case BOX_CORNER_XYZ: vector = new Ogre::Vector3(mMaximum.x, mMaximum.y, mMaximum.z ); break;
    	}
    	
    	//vector->Print();
    	return vector;
       };

    inline bool intersects(Ogre::Vector3 * v) {
        	return Ogre::AxisAlignedBox::intersects(*v); 
        };

    ~BBox();

};

}
#endif
