#ifndef _IMGBSP_H
#define _IMGBSP_H


#include "IMGNodeBsp.h"

namespace IMG {

class Bsp {
  public:
    inline Bsp() : root(NULL), countleaf(0), counttotal(0){};

    inline void SetRoot(NodeBsp * node) {
    		root = node;
    		counttotal++;
    	};

    inline void Print() {
    		printf("\nImprimint Arbre BSP, num nodes leaf: %d, totals: %d", countleaf, counttotal);
    		Print(root);
    	};

    inline void PrintLeaf() {
    		PrintLeaf(root);
    	};

    inline NodeBsp * Insert(int w, int h, int idcluster) {
    		//printf("\nInsret dins Bsp: %d, %d", w, h);
    		
    		NodeBsp *node = root->Insert (w,h);
    		
    		//printf("\nNode on s'insertarà finalment éS: "); node->Print();
    		
    		if (idcluster != -1)
    		{
    			node->SetId (idcluster);
    			countleaf++;			
    		}
    		else counttotal++;
    		
    		//Copiar pixels de la imatge al node
    		
    		return node;
    	};

    inline NodeBsp * Get(int i) {
    		return root->Get (root, i);
    	};


  private:
    NodeBsp * root;

    int countleaf;

    int counttotal;

    inline void Print(NodeBsp * node) {
    		if (!node) return;
    		node->Print();
    		Print(node->GetChild(0));
    		Print(node->GetChild(1));
    	};

    inline void PrintLeaf(NodeBsp * node) {
    		if (!node) return;
    		
    		
    		if (node->GetChild(0) == NULL && node->GetChild(1) == NULL) node->Print();
    		
    		PrintLeaf (node->GetChild(0));
    		PrintLeaf (node->GetChild(1));
    		
    	};


  public:
    ~Bsp();

};

}
#endif
