#ifndef _IMGCLUSTER_H
#define _IMGCLUSTER_H

#include "IMGPrerequisites.h"
#include "IMGBBox.h"
#include "IMGBox2d.h"
#include "IMGPlane3.h"

namespace IMG { class Cluster2d; } 

namespace IMG {

class Cluster {
  public:
    Cluster();

    Cluster & operator =(const Cluster & p);

    Cluster(const Cluster & p);

    // Gametools -- Isma 17/08/2005
    //void Insert (Triangle *t);
    // Gametools -- Isma 17/08/2005
    //* return the patchs that the point is in
    //int CalculaPatch (Vector3 &point);
	inline void SetNormal(Ogre::Vector3* n) { normal = *n; };

	inline Ogre::Vector3* GetNormal() { return &normal; };

    inline BBox* GetBound() { return bound; };

    inline Box2d* GetBspNodeBound() { return bspnodebound; };

    inline void SetBspNodeBound(Box2d* box) {
    		bspnodebound = box;
    	};

    void Print();

    //* return the dominant normal axis, for calculate the 2d projection
    int AxisProjected();

    inline int GetId() const { return id; };

    inline void SetId(int id_) { id = id;};

    //Vector3 * GetVector3s() const{ return Vector3s;}
    //Vector3 * GetVector3s();
    //Vector3 * GetVector3s() { return Vector3s_triangle_text; }
	inline std::vector<Ogre::Vector3>* GetVector3sVector() { return &Vector3s_vector; };

	inline Ogre::Vector3* GetVector3sTex() const { return Vector3s_triangle_text;};

    // Gametools -- Isma 17/08/2005
    //bool CreatePatches(bool dinamic = false);
    // Gametools -- Isma 17/08/2005
    //Listid *GetPatchList() { return &patchlistid;}
    //Listid *GetTriangleList(){ return &trianglelistid; }
    // Gametools -- Isma 17/08/2005
    //int GetIdPatch (unsigned int i)
    //{
    //	if (i > patchlistid.GetSize()) return -1;
    //	
    //	return patchlistid.Get(i);
    //}
    // Gametools -- Isma 17/08/2005
    //int GetIdTriangle  (unsigned int i)
    //{
    //	if (i > trianglelistid.GetSize()) return -1;
    //	
    //	return trianglelistid.Get(i);
    //}
    void Finish();

	inline void SetPlane(Ogre::Vector3* normal, Ogre::Vector3 * point) {
    		plane.normal = *normal;
    		plane.normal = -plane.normal;
    		plane.d = -normal->dotProduct (*point);		
    		//plane.d = normal->dotProduct (*point);		
    	};

    inline Plane3 * GetPlane() { return &plane; };

    //* Return the increment in U (lumel increment in x). For patchs calculation 
	Ogre::Vector3 GetIncU();

    //* Return the increment in V (lumel increment in x). For patchs calculation 
	Ogre::Vector3 GetIncV();

    //* Return the origin. For patchs calculation 
	Ogre::Vector3 GetOrigin();

    //
    //	void CreateVector3s()
    //	{ 
    //		
    //		//Vector3s = new Vector3[4];
    //		//Vector3s_triangle_text = new Vector3[4];
    //	}
    //	
	bool PointIn(Ogre::Vector3 & point);

	Ogre::Real *pointeru[4]; //coordentate u for obscurancemap
	Ogre::Real *pointerv[4]; //coordentate v for obscurancemap
	Ogre::Vector2 *uv;	//Vector3 coordenates for the original texture

  private:
    BBox * bound;

    Box2d * bspnodebound;

    static unsigned int ID_CLUSTER;

	Ogre::Vector3 normal;

    unsigned int id;

	std::vector<Ogre::Vector3> Vector3s_vector;
	Ogre::Vector3 *Vector3s;
	Ogre::Vector3 *Vector3s_triangle_text;

    int axisproj;

    int order;

    Cluster2d * triangle2d_text;

	Ogre::Vector3 lumel_origin, lumel_x_axis, lumel_y_axis;
	
    Plane3 plane;

    // Gametools -- Isma 17/08/2005
    //Listid patchlistid;
    //Listid trianglelistid;
	int CalcPatch(Ogre::Vector3 & point);


  public:
    ~Cluster();

};

}
#endif
