#ifndef _IMGVOXELLIST_H
#define _IMGVOXELLIST_H

#include "IMGVoxel.h"
#include "IMGPrerequisites.h"

namespace IMG {

//*
//	this class represents a scene voxels list
//*
class VoxelList {
  public:
    VoxelList();

    //VoxelList(Ogre::AxisAlignedBox *);
	VoxelList(Ogre::Box * );

    //~Voxels();
	inline std::vector<Voxel> * GetList() { return &list;};

    //return the pointer to the list of voxels
    //bool SetBoundBox (Ogre::AxisAlignedBox *);				//set the boundbox
	bool SetBoundBox(Ogre::Box * );

    //set the boundbox
    bool SetBoundBox(float , float , float , float , float , float );

    //Ogre::AxisAlignedBox * GetBoundBox() { return &boundbox;   }	//return pointer to boundbox of scene
	inline Ogre::Box * GetBoundBox() { return &boundbox; };

    //return pointer to boundbox of scene
    inline int GetSize() const { return list.size(); }

    //return the number of elements of list
    Voxel * GetVoxel(unsigned int );

    //return pointer to voxel(i)
    void Print();

    //print stats
    //bool AddPatch2Voxel(Patch *);				//add patch to voxels
    //this function also add the obspoly to voxels
    //int CalculateVoxel(Ogre::Vector3 *);		//calculate the voxel that Vector3 go into, called by AddPatch2Voxel  
	int CalculateVoxel(Ogre::Vector3 * );

    //display the voxels in wireframe mode
    bool CreateVoxels();


  private:
    //scene voxels list
    std::vector<Voxel> list;
	Ogre::Box boundbox;	//bounding box of the scene

    int Under(unsigned int );

    //return the under voxel, -1 if not exist
    int Over(unsigned int );

    //return the over voxel, -1 if not exist
    int Right(unsigned int );

    //return the Right voxel, -1 if not exist
    int Left(unsigned int );

    //return the Left voxel, -1 if not exist
    int Front(unsigned int );

    //return the Front voxel, -1 if not exist
    int Behind(unsigned int );

    //return the Behind voxel, -1 if not exist
    bool FirstX(unsigned int );

    bool FirstY(unsigned int );

    bool FirstZ(unsigned int );

    bool LastX(unsigned int );

    bool LastY(unsigned int );

    bool LastZ(unsigned int );


  public:
    ~VoxelList();

};

}
#endif
